QGIS Application - Bug report #15055
WMS Legend Image is flawed: WMS getLegendGraphic url's get double names/keys
2016-06-17 06:26 AM - Richard Duivenvoorde

Status: Closed

Priority: Normal

Assignee:

Category: Unknown

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 22998
Description

IF a WMS service provides GetLegendGraphic url's in it's capabilities, QGIS tries to retrieve the legendimage and shows it in the
layermanager.

Some services provide full url's, others only parts, that is why in current implementation there is a check IF certain query-names are
available in the url-query and else are added:
https://github.com/qgis/QGIS/blob/master/src/providers/wms/ggswmsprovider.cop#L2993

BUT certain services provide the url in lowercase key/value pairs, resulting in double key/value pairs in the url, resulting in error messages
instead of images.

To test: add a layer from this service:
http://geoservices.knmi.nl/cgi-bin/RADNL _OPER R 25PCPRR L3.cgi?

| have already created a patch for it, and will do a pull request

Associated revisions

Revision 543d5211 - 2016-06-21 09:10 AM - Richard Duivenvoorde

WMS GetLegendGraphic fix #15055 (#3213)

When creating the legend image url, this tests for available queryparams

in a case-insensitive way...

Revision 9bdfa67d - 2016-06-26 05:32 PM - Richard Duivenvoorde

WMS GetLegendGraphic fix #15055

See http://hub.ggis.org/issues/15055

When creating the legend image url, this tests for available queryparams

in a case-insensitive way...

History

#1 - 2016-06-17 06:46 AM - Richard Duivenvoorde

FYI without patch this is te resulting getLegendGraphic url:
https://github.com/qgis/QGIS/blob/master/src/providers/wms/qgswmsprovider.cpp#L2993
http://geoservices.knmi.nl/cgi-bin/RADNL_OPER_R___25PCPRR_L3.cgi
http://hub.qgis.org/issues/15055

http://geoservices.knmi.nl/cgi-bin/RADNL OPER R 25PCPRR_L3.cqi?SERVICE=WMS&#38;&#38;version=1.1.1&#38;service=WMS&#38;request=
etLegendGraphic&#38;layer=RADNL_OPER_R__ 25PCPRR_L3_KNMI&#38;format=image/png&#38;STY LE=default&#38;&#38;VERSION=1.3.0&#38;SLD_VEI
;SLD_VERSION=1.1.0&#38;REQUEST=GetLegendGraphic&#38;FORMAT=image/png&#38;LAYER=RADNL OPER R 25PCPRR_L3 KNMI

#2 - 2016-06-17 06:46 AM - Richard Duivenvoorde
- File legendflawed.png added

#3 - 2016-06-21 12:10 AM - Richard Duivenvoorde

- Status changed from Open to Closed

Fixed in changeset commit:"543d5211332a885960a19b4a7ca7{f3296838a27".

#4 - 2017-09-22 10:05 AM - Jiirgen Fischer

- Category set to Unknown

Files

legendflawed.png 245 KB 2016-06-17 Richard Duivenvoorde
